/*
 * Classe che permette di creare , leggere e scrivere su file
 * 
 */
import java.io.EOFException;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Vector;


public class FileBin 

{
	public static boolean salvaFile (String nomeFile , Vector elenco )
		{
		     try
		     {FileOutputStream f = new FileOutputStream(nomeFile);
		      ObjectOutputStream fOUT = new ObjectOutputStream(f);
		    
		      for(int i=0;i < elenco.size(); i++)
			      {
		    	   fOUT.writeObject(elenco.elementAt(i)); //salvo l'oggetto
			      }		    
		      fOUT.flush();
		      f.close();
		  	  Visual.message("Salvato il file '" + Finestra.estraiNomeFile(nomeFile) + "'");
		  	  return true;
		     }
		     catch(Exception eccez)
		     { Visual.message("Errore durante la scrittura su file : " + eccez.getMessage());  
		       return false;
		     }
		}//fine salvaFile
	
	
	public static boolean creaFile (String nomeFile)
	{
		 try
	     {
			 int scelta = 0;
			  String nomeFileTemp = nomeFile.substring(nomeFile.lastIndexOf("\\")+1, nomeFile.length());
			  if (trovaPercorso(nomeFile)) //se esiste il file chiede se devo sovrascriverlo
				  scelta = Visual.conferma("Il file '" + nomeFileTemp + "' esiste gi !!\nSovraschiverlo ?");
			  if (scelta == 0) //se Visual.conferma ritorna 0 lo salvo 
				  {
			      FileOutputStream f = new FileOutputStream(nomeFile);
			      ObjectOutputStream fOUT = new ObjectOutputStream(f);
			      fOUT.flush();
			      f.close();
			  	  Visual.message("File creato  '" + nomeFileTemp + ".rbc'");
			  	  return true;
			      }
			  else Visual.message("Creazione nuovo file non effettuata!!");
	  	  return false;
	     }
	     catch(Exception eccez)
	     { 
	       Visual.message("Errore nella creazione del file : " + eccez.getMessage());  
	       return false;
	     }
	}//fine creaFile
	
	
	public static boolean leggiFile( String nomeFile , Vector elenco)
	 {
	 if (trovaPercorso(nomeFile))
	    {
		 try
		   { FileInputStream file = new FileInputStream(nomeFile);
		     ObjectInputStream fin = new ObjectInputStream(file);    
		     while(true)
		     { 
		       try
		        {
		          elenco.addElement(fin.readObject());
		        }
		       catch(EOFException e) 
		        { Visual.message("Caricate " + elenco.size() + "  voci nell'elenco");
		          break; 
		        }
		     }
		     file.close();
		     return true;
		   }
		  catch (Exception e)
		   { Visual.message("Errore durante la lettura dal file !" + e);
		     return false;
		   } 
	    }
	 else Visual.message("File non trovato!!");
	 return false;
	 } //fine leggiFile
	
	
	public static boolean trovaPercorso(String nomeFile)
	  {
	  	boolean trovato= false;
	    try
	    {
	      FileReader fileFisico = new FileReader( nomeFile );
	      trovato=true;
	    }
	    catch (IOException e)  { } 	 
	    return trovato;
	  }//fine trovaPercorso
	
}//fine class FileBin

