import java.io.*;
import java.util.Vector;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;


public class XML extends DefaultHandler
{

	  private String nodo;
	  private boolean aCapo = false;
	  static  Vector elenc   = null; 
	  String  s1,s2,s3,s4,salvaS1,salvaS2,salvaS3,salvaS4; 
	  static int conta=0;


	  public static boolean importaFileXML(String nomeFile, Vector elenco)
	   {
	   	  boolean trovato = trovaPercorso(nomeFile); //controlla se esiste il file
	   	  
	   	  if (trovato)
	   	   {
	   	    elenc = elenco;
	   	    trovato = leggiFileXML(nomeFile);
	        elenco=elenc;
	        Visual.message("Caricati " + elenco.size() + "  contatti!");
	        return trovato;
	           	  
	      }
	   	  else 
	   		  	{
	   		     Visual.message("Errore durante la lettura dal file !");
	   		     return trovato; 
	   		  	}
	   }
	  
	  public static boolean trovaPercorso(String nomeFile)
	  {
	  	boolean trovato = false;
	    try
	    {
	      FileReader fileFisico = new FileReader( nomeFile );
	      trovato = true;
	    } 
	    catch (IOException e)  { } 	 
	    return trovato;
	  }
	  
	  
	  public static boolean leggiFileXML(String nomeFile)
	   {  

	    DefaultHandler handler = new XML();
	    SAXParserFactory factory = SAXParserFactory.newInstance();
	    try
	    {
	     out = new OutputStreamWriter(System.out, "UTF8");
	     SAXParser saxParser = factory.newSAXParser();
	     saxParser.parse(nomeFile, handler);
	     return true;
	    }
	    catch (Throwable t) { /*t.printStackTrace();*/ return false;}   
	  }
	  
	  private static Writer out;   
	   

	  public void startElement(String namespaceURI,String lName,String qName,Attributes attrs)throws SAXException
	  {
	    String name = lName;
	    if ("".equals(name)) { nodo=qName; 
	                           /*
	    						if (aCapo)    System.out.print("\n"+"<" + nodo + ">");
	                           else          { System.out.print(""+"<" + nodo + ">");
	                                           aCapo = true;
	                                         }
	                           */
	                           
	                         }
	  }

	  public void endElement(String namespaceURI,String sName,String qName) throws SAXException
	   {  String name = sName;
	      if ("".equals(name)) { nodo=qName; 	                             
	                             //System.out.println("</" + nodo + ">");  
	                             
	                             if(nodo=="nome")        
	                            	 {
	                            	 if((int)s1.charAt(0) == 10 ) s1 = "";
	                            	 salvaS1=s1; 
	                            	 }
	                             if(nodo=="cognome")     
	                            	 {
	                            	 if((int)s2.charAt(0) == 10 ) s2 = "";
	                            	 salvaS2=s2;
	                            	 }
	                             if(nodo=="telefono")    
	                            	 {
	                            	 if((int)s3.charAt(0) == 10 ) s3 = "";
	                            	 salvaS3=s3; 
	                            	 }
	                             if(nodo=="email")       
	                            	 {
	                            	 if((int)s4.charAt(0) == 10 ) s4 = "";
	                            	 salvaS4=s4;
	                            	 }
	                             
	                             if(nodo=="CONTATTO")
	                             {
	                              Contatto v = new Contatto(salvaS1,salvaS2,salvaS3,salvaS4); 
	                              elenc.addElement(v);     
	                              conta++;
	                             }
	                           }
	                 
	                           
	   }

	  public void characters(char buf[], int offset, int len) throws SAXException
	  {
	   String s = new String(buf, offset, len);
	   if(s.length()>0)
	    {       
	        
	    
	        Contatto v = null;
	        
	        if(nodo=="nome")        { s1=s;  
	                                                  //System.out.println(s); 
	                                                }
	        if(nodo=="cognome")     { s2=s;  
	                                                  //System.out.println(s); 
	                                                }  
	        if(nodo=="telefono")    { s3=s;  
	                                                  //System.out.println(s); 
	                                                }
	        if(nodo=="email") 
	                            {
	                              s4 = s;  //System.out.println(s);          
	                              //v = new Contatto(s1,s2,s3,s4); 
	                              //elenc.addElement(v);     
	                              //conta++;   	
	                            }         
	        aCapo = false;
	    }
	  } 	 
	  				//la variabile salvataggio consente di determinare se si stanno salvando le modifiche o se si sta esportando un nuovo archivio
	public static boolean esportaFileXML(String nomeFile, Vector elenco , boolean salvataggio)
	  {

	  	try
	  	 {                                                      
	  		int scelta = 0;
			String nomeFileTemp = nomeFile.substring(nomeFile.lastIndexOf("\\")+1, nomeFile.length()-4);
			if (trovaPercorso(nomeFile) && !salvataggio) //se esiste il file e non si tratta di un salvataggio chiede se deve sovrascriverlo
				  scelta = Visual.conferma("Il file '" + nomeFileTemp + ".xml' esiste gi !!\nSovraschiverlo ?");
			if (scelta == 0)
	  	  	{
			  FileWriter fileFisico = new FileWriter(nomeFile, false); // false sovrascrive  	  													         
		  	  BufferedWriter fout     = new BufferedWriter(fileFisico);
		      fout.write("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"); 	
		  	  fout.write("<RUBRICA>"); 
		  	  fout.newLine();
		  	
		      for(int i=0; i<elenco.size(); i++)
			      { 
			       Contatto v = (Contatto) elenco.elementAt(i);
			       String nome= "" + v.getNome();
			       String cognome = "" + v.getCognome();
			       String telefono = "" + v.getTelefono();
			       String email = "" + v.getEmail();
			              
			  	   fout.write("<CONTATTO>");     
			  	   fout.newLine();  	  	      	 
			  	   fout.write("<nome>"+ nome +"</nome>");
			  	   fout.newLine();   
			  	   fout.write("<cognome>" + cognome  +"</cognome>");
			  	   fout.newLine();     	   
			  	   fout.write("<telefono>" + telefono  +"</telefono>");
			  	   fout.newLine();     	   
			  	   fout.write("<email>" + email + "</email>");
			  	   fout.newLine(); 
			  	   fout.write("</CONTATTO>"); 
			  	   fout.newLine(); 	 
			      }   	
		  	  fout.write("</RUBRICA>");  	   	
		      fout.close();
		      Visual.message("Esportazione in Xml effettuata!! " + nomeFileTemp);
		      return true;
	  	  	}
	  	  else 
	  		  {
	  		  Visual.message("Esportazione in Xml non effettuata!!");
	  		  return false;
	  		  }
	  		  
	  	 }
	  	catch(IOException e) 
	  	 { 
	  		Visual.message("Errore nel salvataggio del file Xml !!");
	  		return false;
	     }      
	  }//fine salvaFile
}//fine class XML
